package com.dsic.gj_erp.controller.jhgk;


import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.dsic.gj_erp.annotation.AuthFunction;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jcsj.DmCzplpNew;
import com.dsic.gj_erp.bean.jhgk.DmYdjh;
import com.dsic.gj_erp.bean.kc.ImCkwpkwp;
import com.dsic.gj_erp.service.jcsj.DmCzplpNewService;
import com.dsic.gj_erp.service.jcsj.DmCzplpService;
import com.dsic.gj_erp.service.jhgk.DmYdjhService;
import com.dsic.gj_erp.service.kc.ImCkwpkwpService;
import org.mapstruct.factory.Mappers;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.concurrent.atomic.AtomicInteger;
import java.util.stream.Collectors;
import java.util.stream.Stream;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author xn
 * @since 2023-11-09
 */
@RestController
@RequestMapping("/dmYdjh")
public class DmYdjhController {

    @Autowired
    private DmYdjhService service;
    @Autowired
    private ImCkwpkwpService kcService;

    @Autowired
    private DmCzplpNewService czplpNewService;

    @RequestMapping("/getList")
    @AuthFunction
    public ResultBean getList(@RequestBody Map<String, String> map){
        List<DmYdjh> list= service.list(new QueryWrapper<DmYdjh>()
                .eq(StrUtil.isNotEmpty(map.get("dcCh")),"dc_ch",map.get("dcCh"))
                .eq(StrUtil.isNotEmpty(map.get("zt")),"zt",map.get("zt"))
                .ge(StrUtil.isNotEmpty(map.get("yf")), "jssj", DateUtil.beginOfMonth(DateUtil.parseDate(map.get("yf"))).toString("yyyy/MM/dd"))
                .le(StrUtil.isNotEmpty(map.get("yf")), "jssj", DateUtil.endOfMonth(DateUtil.parseDate(map.get("yf"))).toString("yyyy/MM/dd"))
                .orderByAsc("jssj,dc_ch,dc_pl,zl,lqlb")
        );

        Map<String, List<DmYdjh>> collect = list.stream().collect(Collectors.groupingBy(DmYdjh::getDcCh));
        List<Map<String, Object>> resultMap=new ArrayList<>();
        //验证数据获取方法,后续可以都在这里进行获取
        collect.forEach((key,val)->{
            List<ImCkwpkwp> bcKcxx = kcService.getBcKcxx(key);
            List<DmCzplpNew> czplpNewList = czplpNewService.list(Wrappers.<DmCzplpNew>lambdaQuery()
                    .eq(DmCzplpNew::getDcCh, key)
            );
            val.forEach(item->{
                Map<String, Object> itemMap = BeanUtil.beanToMap(item);
                resultMap.add(itemMap);
                bcKcxx.forEach(kc->{
                    if (item.getDcCh().equals(kc.getDcCh())
                            &&item.getDcFd().equals(kc.getDcPl())
                            &&item.getTzbh().equals(kc.getDcTh())){
                        itemMap.put("kc",kc);
                    }
                });
                czplpNewList.forEach(czplpNew->{
                    if (item.getDcCh().equals(czplpNew.getDcCh())&&item.getDcPl().equals(czplpNew.getDcPl())){
                        itemMap.put("czplpNew",czplpNew);
                    }
                });
            });
        });
        return new ResultBean(resultMap);
    }

    @RequestMapping("/hz")
    @AuthFunction
    public ResultBean hz(String from,String to){
        return new ResultBean(service.hz2(from,to));
    }


//    @RequestMapping("/hz")
//    @AuthFunction
//    public ResultBean hz(@RequestBody List<DmYdjh> list){
//        return new ResultBean(service.hz(list));
//    }

    @RequestMapping("/tj")
    @AuthFunction
    public ResultBean tj(@RequestBody List<DmYdjh> list){
        List<String> idList=list.stream().map(DmYdjh::getId).collect(Collectors.toList());

        if (idList.size()>1000){
            AtomicInteger index=new AtomicInteger(idList.size()/1000+1);
            service.update(new UpdateWrapper<DmYdjh>().set("zt","1")
                    .in( "id",idList.subList(idList.size()/1000*1000, idList.size()))
            );
            do {
                int i = index.decrementAndGet();
                List<String> list1 = idList.subList((index.get()-1)*1000, i*1000);
                service.update(new UpdateWrapper<DmYdjh>().set("zt","1")
                        .in( "id",list1)
                );
            }while (index.get()>1);
        }else {
            service.update(new UpdateWrapper<DmYdjh>().set("zt","1")
                    .in( "id",idList)
            );
        }

        return new ResultBean();
    }




    @RequestMapping("/xf")
    @AuthFunction
    public ResultBean xf(@RequestBody List<DmYdjh> list){
            service.xf(list);
        return new ResultBean();
    }

}

