package com.dsic.gj_erp.controller.pgd;


import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.dsic.gj_erp.annotation.AuthFunction;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.pgd.PgdSljh;
import com.dsic.gj_erp.bean.pgd.PgdTzjh;
import com.dsic.gj_erp.exception.CustomException;
import com.dsic.gj_erp.service.pgd.PgdSljhService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author xn
 * @since 2023-11-13
 */
@RestController
@RequestMapping("/pgdSljh")
public class PgdSljhController {
    
    
    @Autowired
    PgdSljhService pgdSljhService;


    @PostMapping("/getSljhPgd")
    @ResponseBody
    public ResultBean getSljhPgd(HttpServletRequest req, @RequestBody Map map) throws Exception, CustomException {
        QueryWrapper<PgdSljh> qw =new QueryWrapper<>();


        qw.eq(StrUtil.isNotEmpty((String)map.get("dcch")),"czbh",(String)map.get("dcch"));
        qw.eq(StrUtil.isNotEmpty((String)map.get("pl")),"pl",(String)map.get("pl"));
        qw.eq(StrUtil.isNotEmpty((String)map.get("fd")),"fd",(String)map.get("fd"));
        qw.eq(StrUtil.isNotEmpty((String)map.get("zt")),"zt",(String)map.get("zt"));
        qw.orderBy(true,true,"czbh","pl","fd");
        return new ResultBean(pgdSljhService.list(qw));

    }




    @PostMapping("/saveSljhPg")
    @ResponseBody
    @AuthFunction
    public ResultBean saveSljhPg(HttpServletRequest req, @RequestBody List<PgdSljh> list) throws Exception, CustomException {
        pgdSljhService.saveSljhPg(list,req);
        return new ResultBean();
    }

    @PostMapping("/saveSljhPgBack")
    @ResponseBody
    @AuthFunction
    public ResultBean saveSljhPgBack(HttpServletRequest req, @RequestBody List<PgdSljh> list) throws Exception, CustomException {
        pgdSljhService.saveSljhPgBack(list,req);
        return new ResultBean();
    }

    @PostMapping("/saveSljhPgdXd")
    @ResponseBody
    @AuthFunction
    public ResultBean saveSljhPgdXd(HttpServletRequest req, @RequestBody List<PgdSljh> list) throws Exception, CustomException {
        pgdSljhService.saveSljhPgdXd(list,req);
        return new ResultBean();
    }

    @PostMapping("/saveSljhPgdXdBack")
    @ResponseBody
    @AuthFunction
    public ResultBean saveSljhPgdXdBack(HttpServletRequest req, @RequestBody List<PgdSljh>list) throws Exception, CustomException {
        pgdSljhService.saveSljhPgdXdBack(list,req);
        return new ResultBean();
    }



    @PostMapping("/saveSljhPgdFk")
    @ResponseBody
    @AuthFunction
    public ResultBean saveSljhPgdFk(HttpServletRequest req, @RequestBody List<PgdSljh>list) throws Exception, CustomException {
        pgdSljhService.saveSljhPgdFk(list,req);
        return new ResultBean();
    }

    @PostMapping("/saveSljhFk")
    @ResponseBody
    @AuthFunction
    public ResultBean saveSljhFk(HttpServletRequest req, @RequestBody List<PgdSljh>list) throws Exception, CustomException {
        pgdSljhService.saveSljhFk(list,req);
        return new ResultBean();
    }

}

