package com.dsic.gj_erp.datasync;

import cn.hutool.core.date.DateField;
import cn.hutool.core.date.DateTime;
import cn.hutool.core.util.ObjUtil;
import cn.hutool.http.HttpUtil;
import com.alibaba.fastjson.JSONObject;
import lombok.RequiredArgsConstructor;
import org.springframework.context.annotation.DependsOn;
import org.springframework.stereotype.Component;

import java.util.Map;

//@Component
@DependsOn("config")
@RequiredArgsConstructor
public class DataHandler {

    private final Config config;
    private String token;
    private DateTime expTime;
    private String userCode;
    private String xAuthToken;

    public JSONObject execute(String methodName, JSONObject param){
        if (ObjUtil.isEmpty(expTime)||DateTime.now().after(expTime)){
            this.getToken();
        }

        String result = HttpUtil.createPost(config.getRequestUrl(methodName))
                .header(config.getTokenName(), token)
                .header(config.getTypeName(), config.getAuthType())
                .header(config.getChannelCodeName(), config.getChannelCode())
                .header(config.get_channelCodeName(), config.get_channelCode())
                .header(config.getXAuthTokenName(), xAuthToken)
                .header(config.getUserCodeName(), userCode)
                .body(JSONObject.toJSONString(param))
                .execute().body();
        try {
            return JSONObject.parseObject(result);
        }catch (Exception e){
            e.printStackTrace();
        }
        return null;
    }

    public JSONObject getToken(){
        Map<String, Object> loginFormData = config.getLoginFormData();
        String result = HttpUtil.createPost(config.getRequestUrl(MethodType.login.name()))
                .header(config.getTypeName(), config.getAuthType())
                .header(config.getChannelCodeName(), config.getChannelCode())
                .header(config.get_channelCodeName(), config.get_channelCode())
                .form(loginFormData)
                .execute().body();
        try {
            JSONObject loginResult = JSONObject.parseObject(result);
            this.token=loginResult.getString(config.getTokenName());
            this.expTime =DateTime.now().offset(DateField.SECOND,config.getTokenExpTime()-120);
            this.xAuthToken=loginResult.getString(config.getXAuthTokenName());
            this.userCode= (String) loginFormData.get("usercode");
        }catch (Exception e){
            e.printStackTrace();
        }

        return null;
    }

}
